(window.webpackJsonp=window.webpackJsonp||[]).push([[107],{162:function(e,t,n){"use strict";n.r(t),n.d(t,"frontMatter",(function(){return c})),n.d(t,"metadata",(function(){return b})),n.d(t,"rightToc",(function(){return o})),n.d(t,"default",(function(){return p}));var a=n(2),r=n(6),i=(n(0),n(311)),c={title:"Query Arguments"},b={unversionedId:"arguments",id:"arguments",isDocsHomePage:!1,title:"Query Arguments",description:"When a user interacts with components on a page - like typing in text, making choices, clicking buttons, and so on - that information is available to your app in the form of query arguments.",source:"@site/docs/arguments.md",slug:"/arguments",permalink:"/wave/docs/arguments",editUrl:"https://github.com/h2oai/wave/edit/master/website/docs/arguments.md",version:"current",sidebar:"someSidebar",previous:{title:"Components",permalink:"/wave/docs/components"},next:{title:"State",permalink:"/wave/docs/state"}},o=[{value:"Interpreting arguments",id:"interpreting-arguments",children:[]},{value:"Handling interactivity",id:"handling-interactivity",children:[]}],l={rightToc:o};function p(e){var t=e.components,n=Object(r.a)(e,["components"]);return Object(i.b)("wrapper",Object(a.a)({},l,n,{components:t,mdxType:"MDXLayout"}),Object(i.b)("p",null,"When a user interacts with ",Object(i.b)("a",Object(a.a)({parentName:"p"},{href:"/wave/docs/components"}),"components")," on a page - like typing in text, making choices, clicking buttons, and so on - that information is available to your app in the form of ",Object(i.b)("em",{parentName:"p"},"query arguments"),"."),Object(i.b)("p",null,"The query arguments can be read from ",Object(i.b)("inlineCode",{parentName:"p"},"q.args"),", a read-only dictionary-like object passed to your ",Object(i.b)("inlineCode",{parentName:"p"},"@app()")," handler:"),Object(i.b)("pre",null,Object(i.b)("code",Object(a.a)({parentName:"pre"},{className:"language-py",metastring:"{5-7}","{5-7}":!0}),"from h2o_wave import Q, main, app\n\n@app('/foo')\nasync def serve(q: Q):\n    print(q.args.foo)\n    print(q.args.bar)\n    print(q.args.qux)\n")),Object(i.b)("div",{className:"admonition admonition-tip alert alert--success"},Object(i.b)("div",Object(a.a)({parentName:"div"},{className:"admonition-heading"}),Object(i.b)("h5",{parentName:"div"},Object(i.b)("span",Object(a.a)({parentName:"h5"},{className:"admonition-icon"}),Object(i.b)("svg",Object(a.a)({parentName:"span"},{xmlns:"http://www.w3.org/2000/svg",width:"12",height:"16",viewBox:"0 0 12 16"}),Object(i.b)("path",Object(a.a)({parentName:"svg"},{fillRule:"evenodd",d:"M6.5 0C3.48 0 1 2.19 1 5c0 .92.55 2.25 1 3 1.34 2.25 1.78 2.78 2 4v1h5v-1c.22-1.22.66-1.75 2-4 .45-.75 1-2.08 1-3 0-2.81-2.48-5-5.5-5zm3.64 7.48c-.25.44-.47.8-.67 1.11-.86 1.41-1.25 2.06-1.45 3.23-.02.05-.02.11-.02.17H5c0-.06 0-.13-.02-.17-.2-1.17-.59-1.83-1.45-3.23-.2-.31-.42-.67-.67-1.11C2.44 6.78 2 5.65 2 5c0-2.2 2.02-4 4.5-4 1.22 0 2.36.42 3.22 1.19C10.55 2.94 11 3.94 11 5c0 .66-.44 1.78-.86 2.48zM4 14h5c-.23 1.14-1.3 2-2.5 2s-2.27-.86-2.5-2z"})))),"tip")),Object(i.b)("div",Object(a.a)({parentName:"div"},{className:"admonition-content"}),Object(i.b)("p",{parentName:"div"},Object(i.b)("inlineCode",{parentName:"p"},"q.args")," is an ",Object(i.b)("a",Object(a.a)({parentName:"p"},{href:"api/core#Expando"}),"Expando")," instance, which means it behaves both like a dictionary and an object: ",Object(i.b)("inlineCode",{parentName:"p"},"q.args['foo']")," is the same as ",Object(i.b)("inlineCode",{parentName:"p"},"q.args.foo"),". ",Object(i.b)("inlineCode",{parentName:"p"},"q.args.foo")," is easier to read."))),Object(i.b)("h2",{id:"interpreting-arguments"},"Interpreting arguments"),Object(i.b)("p",null,"The table below summarizes how to interpret inputs from various components."),Object(i.b)("table",null,Object(i.b)("thead",{parentName:"table"},Object(i.b)("tr",{parentName:"thead"},Object(i.b)("th",Object(a.a)({parentName:"tr"},{align:null}),"Component"),Object(i.b)("th",Object(a.a)({parentName:"tr"},{align:null}),"If the component is named ",Object(i.b)("inlineCode",{parentName:"th"},"foo"),", the value of ",Object(i.b)("inlineCode",{parentName:"th"},"q.args.foo")," is..."))),Object(i.b)("tbody",{parentName:"table"},Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.button()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"value")," if provided, else ",Object(i.b)("inlineCode",{parentName:"td"},"True"),".")),Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.checkbox()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"True")," if checked, ",Object(i.b)("inlineCode",{parentName:"td"},"False")," if unchecked, ",Object(i.b)("inlineCode",{parentName:"td"},"None")," if indeterminate.")),Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.checklist()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),"A list of names of all the selected choices (a list of strings).")),Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.choice_group()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),"The name of the selected choice (a string).")),Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.color_picker()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),"The selected color (a string).")),Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.combobox()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),"Either the name of the selected choice or the value typed in (a string).")),Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.command()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"value")," if provided, else ",Object(i.b)("inlineCode",{parentName:"td"},"True"),".")),Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.date_picker()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),"The selected date in ",Object(i.b)("inlineCode",{parentName:"td"},"YYYY-MM-DD")," format (a string).")),Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.dropdown()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),"If multi-valued, a list of names of all the selected choices (a list of strings), otherwise the name of the selected choice (a string).")),Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.expander()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"True")," if expanded, else ",Object(i.b)("inlineCode",{parentName:"td"},"False"),".")),Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.file_upload()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),"A list of paths to the uploaded files (a list of strings).")),Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.nav_item()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"True")," if clicked.")),Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.picker()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),"A list of names of all the selected choices (a list of strings).")),Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.range_slider()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"[min, max]")," (a list of two numbers).")),Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.slider()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),"The selected value (a number).")),Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.spinbox()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),"The selected value (a number).")),Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.table()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),"A list of names of all the selected rows (a list of strings).")),Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.tabs()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),"The name of the active tab (a string).")),Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.textbox()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),"The value typed in (a string).")),Object(i.b)("tr",{parentName:"tbody"},Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"ui.toggle()")),Object(i.b)("td",Object(a.a)({parentName:"tr"},{align:null}),Object(i.b)("inlineCode",{parentName:"td"},"True")," if checked, ",Object(i.b)("inlineCode",{parentName:"td"},"False")," if unchecked.")))),Object(i.b)("h2",{id:"handling-interactivity"},"Handling interactivity"),Object(i.b)("p",null,"A common pattern for inspecting query arguments and determining the appropriate response is a simple ",Object(i.b)("inlineCode",{parentName:"p"},"if/elif/else")," conditional."),Object(i.b)("p",null,"If ",Object(i.b)("inlineCode",{parentName:"p"},"add_to_cart"),", ",Object(i.b)("inlineCode",{parentName:"p"},"empty_cart"),", ",Object(i.b)("inlineCode",{parentName:"p"},"place_order")," and ",Object(i.b)("inlineCode",{parentName:"p"},"display_products")," are all names of buttons somewhere in the user interface, then you can structure your ",Object(i.b)("inlineCode",{parentName:"p"},"serve()")," function something like this:"),Object(i.b)("pre",null,Object(i.b)("code",Object(a.a)({parentName:"pre"},{className:"language-py",metastring:"{17-24}","{17-24}":!0}),"from h2o_wave import Q, main, app\n\nasync def add_to_cart(q: Q):\n    pass\n\nasync def empty_cart(q: Q):\n    pass\n\nasync def place_order(q: Q):\n    pass\n\nasync def display_products(q: Q):\n    pass\n\n@app('/hole_foods')\nasync def serve(q: Q):\n    if q.args.add_to_cart:\n        await add_to_cart(q)\n    elif q.args.empty_cart:\n        await empty_cart(q)\n    elif q.args.place_order:\n        await place_order(q)\n    else: # Display products\n        await display_products(q)\n\n")),Object(i.b)("p",null,"If this feels too repetitive, you can use ",Object(i.b)("inlineCode",{parentName:"p"},"on")," and ",Object(i.b)("inlineCode",{parentName:"p"},"handle_on")," to remove some of the boilerplate:"),Object(i.b)("pre",null,Object(i.b)("code",Object(a.a)({parentName:"pre"},{className:"language-py",metastring:"{3,7,11,15,21}","{3,7,11,15,21}":!0}),"from h2o_wave import Q, main, app, on, handle_on\n\n@on('add_to_cart')\nasync def add_to_cart(q: Q):\n    pass\n\n@on('empty_cart')\nasync def empty_cart(q: Q):\n    pass\n\n@on('place_order')\nasync def place_order(q: Q):\n    pass\n\n@on('display_products')\nasync def display_products(q: Q):\n    pass\n\n@app('/hole_foods')\nasync def serve(q: Q):\n    await handle_on(q)\n\n")),Object(i.b)("p",null,"In the above example, the ",Object(i.b)("inlineCode",{parentName:"p"},"@on('add_to_cart')"),' is read as "when ',Object(i.b)("inlineCode",{parentName:"p"},"q.arg['add_to_cart']")," is ",Object(i.b)("inlineCode",{parentName:"p"},"True")," (or truthy), then invoke the function the ",Object(i.b)("inlineCode",{parentName:"p"},"@on()"),' is applied to" - in this case, ',Object(i.b)("inlineCode",{parentName:"p"},"add_to_cart()"),"."),Object(i.b)("p",null,"If the name of the function is the same as the name of the query argument, then the name can be elided. This simplifies the above example to:"),Object(i.b)("pre",null,Object(i.b)("code",Object(a.a)({parentName:"pre"},{className:"language-py",metastring:"{3,7,11,15}","{3,7,11,15}":!0}),"from h2o_wave import Q, main, app, on, handle_on\n\n@on()\nasync def add_to_cart(q: Q):\n    pass\n\n@on()\nasync def empty_cart(q: Q):\n    pass\n\n@on()\nasync def place_order(q: Q):\n    pass\n\n@on()\nasync def display_products(q: Q):\n    pass\n\n@app('/hole_foods')\nasync def serve(q: Q):\n    await handle_on(q)\n\n")),Object(i.b)("div",{className:"admonition admonition-tip alert alert--success"},Object(i.b)("div",Object(a.a)({parentName:"div"},{className:"admonition-heading"}),Object(i.b)("h5",{parentName:"div"},Object(i.b)("span",Object(a.a)({parentName:"h5"},{className:"admonition-icon"}),Object(i.b)("svg",Object(a.a)({parentName:"span"},{xmlns:"http://www.w3.org/2000/svg",width:"12",height:"16",viewBox:"0 0 12 16"}),Object(i.b)("path",Object(a.a)({parentName:"svg"},{fillRule:"evenodd",d:"M6.5 0C3.48 0 1 2.19 1 5c0 .92.55 2.25 1 3 1.34 2.25 1.78 2.78 2 4v1h5v-1c.22-1.22.66-1.75 2-4 .45-.75 1-2.08 1-3 0-2.81-2.48-5-5.5-5zm3.64 7.48c-.25.44-.47.8-.67 1.11-.86 1.41-1.25 2.06-1.45 3.23-.02.05-.02.11-.02.17H5c0-.06 0-.13-.02-.17-.2-1.17-.59-1.83-1.45-3.23-.2-.31-.42-.67-.67-1.11C2.44 6.78 2 5.65 2 5c0-2.2 2.02-4 4.5-4 1.22 0 2.36.42 3.22 1.19C10.55 2.94 11 3.94 11 5c0 .66-.44 1.78-.86 2.48zM4 14h5c-.23 1.14-1.3 2-2.5 2s-2.27-.86-2.5-2z"})))),"tip")),Object(i.b)("div",Object(a.a)({parentName:"div"},{className:"admonition-content"}),Object(i.b)("p",{parentName:"div"},Object(i.b)("inlineCode",{parentName:"p"},"@on()")," also supports pattern matching. See ",Object(i.b)("a",Object(a.a)({parentName:"p"},{href:"/wave/docs/routing"}),"Routing")," for more information."))))}p.isMDXComponent=!0},311:function(e,t,n){"use strict";n.d(t,"a",(function(){return d})),n.d(t,"b",(function(){return O}));var a=n(0),r=n.n(a);function i(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function c(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var a=Object.getOwnPropertySymbols(e);t&&(a=a.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,a)}return n}function b(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{};t%2?c(Object(n),!0).forEach((function(t){i(e,t,n[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(n)):c(Object(n)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(n,t))}))}return e}function o(e,t){if(null==e)return{};var n,a,r=function(e,t){if(null==e)return{};var n,a,r={},i=Object.keys(e);for(a=0;a<i.length;a++)n=i[a],t.indexOf(n)>=0||(r[n]=e[n]);return r}(e,t);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);for(a=0;a<i.length;a++)n=i[a],t.indexOf(n)>=0||Object.prototype.propertyIsEnumerable.call(e,n)&&(r[n]=e[n])}return r}var l=r.a.createContext({}),p=function(e){var t=r.a.useContext(l),n=t;return e&&(n="function"==typeof e?e(t):b(b({},t),e)),n},d=function(e){var t=p(e.components);return r.a.createElement(l.Provider,{value:t},e.children)},s={inlineCode:"code",wrapper:function(e){var t=e.children;return r.a.createElement(r.a.Fragment,{},t)}},m=r.a.forwardRef((function(e,t){var n=e.components,a=e.mdxType,i=e.originalType,c=e.parentName,l=o(e,["components","mdxType","originalType","parentName"]),d=p(n),m=a,O=d["".concat(c,".").concat(m)]||d[m]||s[m]||i;return n?r.a.createElement(O,b(b({ref:t},l),{},{components:n})):r.a.createElement(O,b({ref:t},l))}));function O(e,t){var n=arguments,a=t&&t.mdxType;if("string"==typeof e||a){var i=n.length,c=new Array(i);c[0]=m;var b={};for(var o in t)hasOwnProperty.call(t,o)&&(b[o]=t[o]);b.originalType=e,b.mdxType="string"==typeof e?e:a,c[1]=b;for(var l=2;l<i;l++)c[l]=n[l];return r.a.createElement.apply(null,c)}return r.a.createElement.apply(null,n)}m.displayName="MDXCreateElement"}}]);